import java.util.*;

public class MyClass
implements Iterable<String>, Iterator<String>
{
	private String[] x;
	private int iteratorIndex;

	public MyClass()
	{
		this.x = new String[2];
		this.x[0] = "Hello";
		this.x[1] = "world";
	}

	public MyClass(String[] s)
	{
		this.x = new String[s.length];
		for (int i = 0; i < s.length; i++)
		{
			this.x[i] = s[i];
		}
	}

	public MyClass(MyClass m)
	{
		this(m.x);
		this.iteratorIndex = m.iteratorIndex;
	}

	public Iterator<String> iterator()
	{
		// create an iterator for this object
		// and return it
		// The current object is its own iterator
		MyClass m = new MyClass(this);
		m.iteratorIndex = 0;
		return m;
	}

	public boolean hasNext()
	{
		// iteratorIndex points to the next
		// element of the list to be returned
		if (this.iteratorIndex < x.length)
			return true;
		return false;
	}

	public String next() throws NoSuchElementException
	{
		// check to see if iteratorIndex is valid
		// if so, return the element and increment 
		// iteratorIndex
		// otherwise, throw NoSuchElementException
		if (this.hasNext())
		{
			int tempIndex = this.iteratorIndex;
			this.iteratorIndex++;
			return this.x[tempIndex];
		}
		throw new NoSuchElementException();
	}

	public void remove() throws UnsupportedOperationException
	{
		throw new UnsupportedOperationException();
	}
}
		
