public class Student
{
	private String name;
	private int grade;

	/**
		Creates a student with the given name and raw grade.

		@param name Student's name
		@param grade Student's raw grade
	*/
	public Student(String name, int grade)
	{
		this.name = name;
		this.grade = grade;
	}

	/**
		Creates a student with name "Jane Doe" and grade 0.
	*/
	public Student()
	{
		this("Jane Doe",0);
	}

	/**
		Returns the student's name.

		@return Student's name
	*/
	public String getName()
	{
		return this.name;
	}

	/**
		Returns the student's raw grade.

		@return Student's raw grade
	*/
	public int getGrade()
	{
		return this.grade;
	}

	/**
		Returns the student's letter grade.
		The grade is "A" for raw grades from 80-100, "B" for 70-79,
		"C" for 60-69, "D" for 50-59, and "F" for 0-49.

		@return Student's letter grade
	*/
	public String getLetterGrade()
	{
		if (grade >= 80) return "A";
		if (grade >= 70) return "B";
		if (grade >= 60) return "C";
		if (grade >= 50) return "D";
		return "F";
	}
}
