public class Employee
implements UniversityPeople
{
	private String name;
	private int salary;

	/**
		Creates an employee with the given name and salary.
		@param name Employee's name
		@param salary Employee's salary
	*/
	public Employee(String name, int salary)
	{
		this.name = name;
		this.salary = salary;
	}

	/**
		Creates an employee with name "Fred Smith" and salary 40000.
	*/
	public Employee()
	{	
		this("Fred Smith",40000);
	}

	/**
		Returns the employee's name.
		@return Employee's name.
	*/
	public String getName()
	{
		return this.name;
	}

	/**
		Returns the employee's salary.
		@return Employee's salary.
	*/
	public int getSalary()
	{
		return this.salary;
	}

	/**
		Generates a report about this employee.
		For example, the default employee's report would read:
		"Employee Fred Smith makes a salary of $40000 per year."
		@return Report about this employee.
	*/
	public String report()
	{
		return "Employee "+this.name+" makes a salary of $"+this.salary+" per year.";
	}
}
