public abstract class Student
{
	private String name;
	private int grade;

	/**
		Creates a student with the given name and raw grade.

		@param name Student's name
		@param grade Student's raw grade
	*/
	public Student(String name, int grade)
	{
		this.name = name;
		this.grade = grade;
	}

	/**
		Creates a student with name "Jane Doe" and grade 80.
	*/
	public Student()
	{
		this("Jane Doe",80);
	}

	/**
		Returns the student's name.

		@return Student's name
	*/
	public String getName()
	{
		return this.name;
	}

	/**
		Returns the student's raw grade.

		@return Student's raw grade
	*/
	public int getGrade()
	{
		return this.grade;
	}

	public abstract String getLetterGrade();

	public String toString()
	{
		return this.name +" "+this.grade;
	}

}
