public class Circle
{

	private MutablePoint p;
	private double radius;

	// Creates a circle with center at the given point, 
	// with the given radius. 
	public Circle(MutablePoint p, double radius)
	{
		this.p = new MutablePoint(p);
		this.radius = radius;
		Circle.num++;
	}


	// Creates a circle at the origin with radius 1. 
	public Circle()
	{
		this(new MutablePoint(),1);
	}

	// Returns the circle's center.
	public MutablePoint getPoint()
	{
		return new MutablePoint(this.p);
	}

	// Returns the radius of the circle. 
	public double getRadius()
	{
		return this.radius;
	}

	public String toString()
	{
		//[Circle:x=0.0,y=0.0,radius=1.0]
		//[Circle:p=???,radius=1.0]
		//call MutablePoint's toString() for ???
		return "[Circle:p="+this.p+",radius="+this.radius+"]";
	}

	public boolean equals(Object o)
	{
		if (o instanceof Circle)
		{
			Circle c = (Circle)o;
			if ((this.radius==c.radius)
				&&((this.p).equals(c.p)))
			{
				return true;
			}
		}
		return false;
	}

	////////////////////////////////////////////
	// Static features
	////////////////////////////////////////////

	private static int num = 0;
	public static final double PI = 3.1416;

	public static double area(double radius)
	{
		return Circle.PI * radius * radius;
	}

	public static double circum(double radius)
	{
		return Circle.PI * 2 * radius;
	}

	public static int numCircles()
	{
		return Circle.num;
	}


}
