public class MutableCircle
{

	// Sets the center point. 
	public double setPoint(MutablePoint p)
	{
		this.p = new MutablePoint(p);
		return 0;
	}

	// Returns the circle's center.
	public MutablePoint getPoint()
	{
		return new MutablePoint(this.p);
	}

	

	private MutablePoint p;
	private double radius;

	// Creates a circle with center at the given point, 
	// with the given radius. 
	public MutableCircle(MutablePoint p, double radius)
	{
		this.p = new MutablePoint(p);
		this.radius = radius;
		MutableCircle.num++;
	}

	// Copy Constructor
	public MutableCircle(MutableCircle c)
	{
		this.radius = c.radius;
		this.p = new MutablePoint(c.p);
	}

	// Creates a circle at the origin with radius 1. 
	public MutableCircle()
	{
		this(new MutablePoint(),1);
	}

	// Returns the radius of the circle. 
	public double getRadius()
	{
		return this.radius;
	}

	public String toString()
	{
		//[Circle:x=0.0,y=0.0,radius=1.0]
		//[Circle:p=???,radius=1.0]
		//call MutablePoint's toString() for ???
		return "[MutableCircle:p="+this.p+",radius="+this.radius+"]";
	}

	public boolean equals(Object o)
	{
		if (o instanceof MutableCircle)
		{
			MutableCircle c = (MutableCircle)o;
			if ((this.radius==c.radius)
				&&((this.p).equals(c.p)))
			{
				return true;
			}
		}
		return false;
	}

        ////////////////////////////////////////////
        // Static features
        ////////////////////////////////////////////

        private static int num = 0;
        public static final double PI = 3.1416;

        public static double area(double radius)
        {
                return MutableCircle.PI * radius * radius;
        }

        public static double circum(double radius)
        {
                return MutableCircle.PI * 2 * radius;   
        }
                
        public static int numCircles()
        {
                return MutableCircle.num;
        }
         
 

}
