public class SearchSortUtil
{
	private SearchSortUtil(){}

	public static int search(int[] x, int target)
	{
		return SearchSortUtil.searchRecur(x, target, 0, x.length-1);
	}

	private static int searchRecur(int[] x, int target, int start, int end)
	{
		int middle = (start+end)/2;

		if (x[middle] == target)
		{
			return middle;
		}
		else if ((x[middle] > target)&&(start <= (middle-1)))
		{
			return searchRecur(x, target, start, middle-1);
		}
		else if ((x[middle] < target)&&((middle+1) <= end))
		{
			return searchRecur(x, target, middle+1, end);
		}
		else // not found
		{
			return -1;
		}		
	}

	public static int[] quickSortRecur(int[] x,int sortLength)
	{
		int middle = sortLength/2;
		int pivot = x[middle];
		int[] low = new int[x.length];
		int[] high = new int[x.length];
		int[] result = new int[x.length];
		int lowCounter = 0;
		int highCounter = 0;

		for (int i = 0; i < sortLength; i++)
		{
			if (x[i] < pivot) 
			{
				low[lowCounter] = x[i];
				lowCounter++;
			}
			else if (x[i] > pivot)
			{
				high[highCounter] = x[i];
				highCounter++;
			}
		}

		System.out.println(middle+" "+lowCounter+" "+highCounter);



		if (lowCounter > 1)
		{
			low = quickSortRecur(low,lowCounter);
		}

		if (highCounter > 1)
		{
			high = quickSortRecur(high,highCounter);
		}

		// reassemble
		int resultCounter = 0;
		for (int i = 0; i < lowCounter; i++)
		{
			result[resultCounter] = low[i];
			resultCounter++;
		}

		result[resultCounter] = pivot;
		resultCounter++;

		for (int i = 0; i < highCounter; i++)
		{
			result[resultCounter] = high[i];
			resultCounter++;
		}

		return result;

	}
		

}
