public class SearchSortUtil
{
	private SearchSortUtil(){}

	public static int searchUnsorted(int[] x, int target)
	{
		for (int i = 0; i < x.length; i++)
		{
			if (x[i] == target)
			{
				// terminates the method
				return i;
			}
		}
		// target is not on the list
		return -1;
	}

	public static int searchSorted(int[] x, int target)
	{
		return searchSortedRecur(x, target, 0, x.length-1);
	}

	private static int searchSortedRecur(int[] x, 
		int target, int start, int end)
	{
		int middle = (start+end)/2;

		System.out.println(start+" "+middle+" "+end);

		// First check the entire stopping case
		if ((x[middle] == target)||((end-start) <= 0))
		{
			System.out.println("Stopping case");
			if (x[middle] == target)
			{
				return middle;
			}
			else
			{
				return -1;
			}
		}
		else if (x[middle] < target)
		{
			System.out.println("Search last half");
			return searchSortedRecur(x, target, middle+1, end);
		}
		else if (x[middle] > target)
		{
			System.out.println("Search first half");
			return searchSortedRecur(x, target, start, middle-1);
		}

		return -2;		

	}

	public static int[] quickSortRecur(int[] x, int sortLength)
	{
		// stopping case
		if (sortLength <= 1)
		{
			return x;
		}

		// length of x is at least 2
		int[] lowList = new int[sortLength];
		int[] highList = new int[sortLength];
		int lowCounter = 0;
		int highCounter = 0;

		int pivot = x[0];

		// remember the first element is the pivot
		for (int i = 1; i < sortLength; i++)
		{
			if (x[i] < pivot)
			{
				lowList[lowCounter] = x[i];
				lowCounter++;
			}
			else // x[i] > pivot
			{
				highList[highCounter] = x[i];
				highCounter++;
			}
		}

		lowList = quickSortRecur(lowList,lowCounter);
		highList = quickSortRecur(highList, highCounter);

		// put the lists back together
		int[] result = new int[sortLength];
		int resultIndex = 0;
		for (int i = 0; i < lowCounter; i++)
		{
			result[resultIndex] = lowList[i];
			resultIndex++;
		}
		
		result[resultIndex] = pivot;
		resultIndex++;

		for (int i = 0; i < highCounter; i++)
		{
			result[resultIndex] = highList[i];
			resultIndex++;
		}

		return result;
	}

}
