public class SearchSortUtil
{
	private SearchSortUtil(){}

	public static int searchUnsorted(int[] x, int target)
	{
		for (int i = 0; i < x.length; i++)
		{
			if (x[i] == target)
			{
				// terminates the method
				return i;
			}
		}
		// target is not on the list
		return -1;
	}

	public static int searchSorted(int[] x, int target)
	{
		return searchSortedRecur(x, target, 0, x.length-1);
	}

	private static int searchSortedRecur(int[] x, 
		int target, int start, int end)
	{
		int middle = (start+end)/2;

		System.out.println(start+" "+middle+" "+end);

		// First check the entire stopping case
		if ((x[middle] == target)||((end-start) <= 0))
		{
			System.out.println("Stopping case");
			if (x[middle] == target)
			{
				return middle;
			}
			else
			{
				return -1;
			}
		}
		else if (x[middle] < target)
		{
			System.out.println("Search last half");
			return searchSortedRecur(x, target, middle+1, end);
		}
		else if (x[middle] > target)
		{
			System.out.println("Search first half");
			return searchSortedRecur(x, target, start, middle-1);
		}

		return -2;		

	}

	public static int[] quickSort(int[] x)
	{
		return SearchSortUtil.quickSortRecur(x, x.length);
	}

	private static int[] quickSortRecur(int[] x, int sortLength)
	{

		// sortLength: sort only elements of x
		// from 0 to sortLength-1
		// i.e., sortLength <= x.length

		// first check the stopping case
		if (sortLength <= 1)
		{
			// list is already sorted
			return x;
		}

		// select a pivot -- first element of the array
		int pivot = x[0];

		// split the original list into 2 sublists:
		// low list -- less than pivot
		// high list -- greater than pivot

		int[] lowList = new int[sortLength];
		int[] highList = new int[sortLength];
		int lowCounter = 0;
		int highCounter = 0;

		// pivot is at x[0]
		for (int i = 1; i < sortLength; i++)
		{
			if (x[i] < pivot)
			{
				lowList[lowCounter] = x[i];
				lowCounter++;
			}
			else // x[i] > pivot
			{
				highList[highCounter] = x[i];
				highCounter++;
			}
		}

		// recursive call to sort the sublists
		lowList = quickSortRecur(lowList,lowCounter);
		highList = quickSortRecur(highList,highCounter);


		// reassemble
		int[] result = new int[sortLength];
		int resultCounter = 0;

		// add the low list
		for (int i = 0; i < lowCounter; i++)
		{
			result[resultCounter] = lowList[i];
			// result[i] = lowList[i];
			resultCounter++;
		}

		// add pivot
		result[resultCounter] = pivot;
		//result[lowCounter] = pivot;
		resultCounter++;

		// add high list
		for (int i = 0; i < highCounter; i++)
		{
			result[resultCounter] = highList[i];
			//result[lowCounter+1+i] = highList[i];
			resultCounter++;
		}

		return result;

	}

	public static void printArray(int[] x, int c)
	{
		for (int i = 0; i < c; i++)
		{
			System.out.print(x[i]+" ");
		}
		System.out.println("");
	}

	public static int[] mergeSort(int[] x)
	{
		// check stopping case
		if (x.length <= 1)
		{
			// stop
			return x;
		}

		// find the middle
		int middle = x.length/2;

		// middle is the start index of the 2nd list
		int[] firstList = new int[middle];
		int[] secondList = new int[x.length-middle];

		// copy x elements into each list
		for (int i = 0; i < middle; i++)
		{
			// copy into first list
			firstList[i] = x[i];
		}

		for (int i = 0; i < (x.length-middle); i++)
		{
			// copy into second list
			secondList[i] = x[i+middle];
		}

		firstList = mergeSort(firstList);
		secondList = mergeSort(secondList);

		x = mergeSortedArrays(firstList,secondList);

		return x;

	}

	public static int[] mergeSortedArrays(int[] x, int[] y)
	{
		int[] result = new int[x.length+y.length];

		int xCounter = 0;
		int yCounter = 0;

		for (int i = 0; i < result.length; i++)
		{
			if ((xCounter < x.length)&&(yCounter < y.length))
			{
				if (x[xCounter] < y[yCounter])
				{
					result[i] = x[xCounter];
					xCounter++;
				}
				else // y[yCounter] < x[xCounter]
				{
					result[i] = y[yCounter];
					yCounter++;
				}
			}
			else if (xCounter < x.length) 
			{
				// xCounter is in bounds
				// but yCounter is not
				// dump x to result
				result[i] = x[xCounter];
				xCounter++;
			}
			else // yCounter < y.length
			{
				// yCounter is in bounds
				// but xCounter is not
				// dump y to result
				result[i] = y[yCounter];
				yCounter++;
			}
		}

		return result;
	}
}
