public class LinkedList
{

	private Node head;

	public LinkedList()
	{
		// empty list
		head = null;
	}

	// walk through the list
	// and get the node at a given position
	// if there is no node at that position
	// i.e. the position is outside the list
	// then return null
	private Node walk(int position)
	{
		Node result = this.head;
		for (int i = 0; i < position; i++)
		{
			// walk through the list
			// "position" number of times
			if (result == null) return null;
			result = result.getNext();
		}
		return result;
	}

	// add newNode to position
	// position is the new position of newNode
	// returns true if add is successful, false otherwise
	public boolean add(int position, Node newNode)
	{
		if (position > 0)
		{
			// get element at position-1
			Node prev = this.walk(position-1);

			if (prev == null) return false; 

			// prev.next has to point to newNode
			// newNode.next has to point to 
			// the old prev.next
			newNode.setNext(prev.getNext());
			prev.setNext(newNode);
			return true;
		}
		// ... finish this later
