public class LinkedList
{
	private Node head;

	public LinkedList()
	{
		head = null;
	}

	private Node walk(int n)
	{
		Node result = head;
		for (int i = 0; i < n; i++)
		{
			result = result.getNext();
			if (result == null) return result;
		}

		return result;
	}

	public boolean add(int position, Node newNode)
	{
		if (position == 0)
		{
			newNode.setNext(this.head);
			this.head = newNode;
			return true;
		}

		Node prev = walk(position-1);

		if (prev == null) return false;

		Node temp = prev.getNext();
		prev.setNext(newNode);
		newNode.setNext(temp);
		return true;
	}

	public boolean del(int position)
	{
		if (position == 0)
		{
			if (head == null)
			{
				return false;
			}
			head = head.getNext();
			return true;
		}

		Node prev = walk(position-1);
		if (prev == null) return false;
		Node delNode = prev.getNext();
		if (delNode == null) return false;
		prev.setNext(delNode.getNext());
		return true;
	}

	public String getData(int position)
	{
		Node posNode = walk(position);
		if (posNode == null) return null;
		return posNode.getData();
	}

}
